#ifndef SRC_ONE_BODY_PROBLEM_DATA_BC_HH
#define SRC_ONE_BODY_PROBLEM_DATA_BC_HH

#include <dune/common/function.hh>

class VelocityDirichletCondition
    : public Dune::VirtualFunction<double, double> {
  void evaluate(double const &relativeTime, double &y) const {
    // Assumed to vanish at time zero
      double const finalVelocity = -5e-5;
    
    //std::cout << "VelocityDirichletCondition::evaluate()" << std::endl;
    
    if (relativeTime <= 0.1)
        std::cout << "- loading phase" << std::endl;
    else
        std::cout << "- final velocity reached" << std::endl;
    
    y = (relativeTime <= 0.1)
            ? finalVelocity * (1.0 - std::cos(relativeTime * M_PI / 0.1)) / 2.0
            : finalVelocity;
  }
};

class NeumannCondition : public Dune::VirtualFunction<double, double> {
  void evaluate(double const &relativeTime, double &y) const { y = 0.0; }
};
#endif
